<?php
/*
 *      Copyright 2007 by Dag Erlandsson (langarod@gmail.com)
 *      This software is distributed under the GNU public license version 2
*/

  include("config.inc");

  $width = 350;
  $height = 100;

  $legendFontSize = 2;

  $secPerPixel = (60*60*24) / $width;

  $feed = trim($_GET['feed']);
  $date = trim($_GET['date']);
  if($feed!='' && $date!='')
  {
    $path_to_images = "$image_root/$feed/$date/";
  }

  $im = @imagecreatetruecolor($width, $height)
    or die("Cannot Initialize new GD image stream");
  $backgroundColor = imagecolorallocate($im, 255, 255, 255);
  imagefilledrectangle($im, 0, 0, $width-1, $height-1, $backgroundColor);

  $footer = imagefontheight($legendFontSize);

  $text_color = imagecolorallocate($im, 0, 0, 0);
  imagestring($im, $legendFontSize, 0, $height - $footer,  "00:00", $text_color);
  imagestring($im, $legendFontSize, $width/4-(imagefontwidth($legendFontSize)*2.5), $height - $footer,  "06:00", $text_color);
  imagestring($im, $legendFontSize, $width/2-(imagefontwidth($legendFontSize)*2.5), $height - $footer,  "12:00", $text_color);
  imagestring($im, $legendFontSize, $width/4*3-(imagefontwidth($legendFontSize)*2.5), $height - $footer,  "18:00", $text_color);
  imagestring($im, $legendFontSize, $width-(imagefontwidth($legendFontSize)*5), $height - $footer,  "24:00", $text_color);

  imagerectangle($im, 0, 0, $width-1, $height - $footer+1, $textColor);

  for($i=0; $i<24; $i++)
    imageline($im, ($width/24)*$i, $height-$footer, ($width/24)*$i, $height-$footer+3, $textColor);
	
  if(isset($path_to_images))
  {
    $dh = opendir( "$path_to_images" );
    $filenames = array();
    while( $file = readdir( $dh ) )
    {
      // look for these file types....
      if (preg_match('/[0-9]\.(jpg|jpeg|gif|png)$/i',$file))
      {
        $filenames[] = $file;
      }
    }
    sort($filenames);

	$files = count($filenames);
	$xTime = 0;
	$maxFrames = 0;
	$frame = 0;
	ereg('([0-9]{2})([0-9]{2})([0-9]{2})', $filenames[$frame], $regs);
	$frameTime = $regs[1]*60*60 + $regs[2]*60 + $regs[3];
	for($x = 0; $x < $width; $x++)
	{
		$xTime+= $secPerPixel;
		$xFrames[$x] = 0;
		while($frameTime < $xTime)
		{
			$frame++;
			if($frame >= $files)
				break;
			$xFrames[$x]++;
			if($xFrames[$x] > $maxFrames)
				$maxFrames = $xFrames[$x];
			ereg('([0-9]{2})([0-9]{2})([0-9]{2})', $filenames[$frame], $regs);
			$frameTime = $regs[1]*60*60 + $regs[2]*60 + $regs[3];
		}
	}

	$lineColor = imagecolorallocate($im, 255, 0, 0);
	for($x = 1; $x < $width; $x++)
	{
		if($xFrames[$x] > 0)
		{
			$y = ($height * $xFrames[$x]) / $maxFrames;
			imageline($im, $x, $height-$footer, $x, $height - $y - $footer, $lineColor);
		}
	}
	$text_color = imagecolorallocate($im, 0xaa, 0xaa, 0xaa);
	imagestring($im, 5, 5, 5,  "$maxFrames $files", $text_color);
  }
  else
  {
	$text_color = imagecolorallocate($im, 0, 0, 0);
	imagestring($im, 5, 5, 5,  "No feed", $text_color);
  }


	header("Expires: " . date("r "));               // Date in the past
	header("Last-Modified: " . date("r "));                          // always modified
//	header("Cache-Control: no-cache, must-revalidate");             // HTTP/1.1
//	header("Pragma: no-cache");                                     // HTTP/1.0
	
	header("Content-type: image/png\n\n");	
	imagepng($im);

	imagedestroy($im);
?>

